Shopping Product
Retrieve detailed Google Shopping product data including pricing, reviews, specifications, and variants using Web Scraper API.
The google_shopping_product source retrieves detailed product information (title, description, pricing, sellers, related items, reviews, etc.) from Google Shopping using a product token acquired from google_shopping_search (here) or google_search.
Request samples
In the code example below, we make a request to retrieve the product page for a Google Shopping product using a valid token.
curl 'https://realtime.oxylabs.io/v1/queries' \
--user 'USERNAME:PASSWORD' \
-H 'Content-Type: application/json' \
-d '{
"source": "google_shopping_product",
"query": "<PRODUCT_TOKEN>",
"render": "html",
"parse": true
}'import requests
from pprint import pprint
# Structure payload.
payload = {
"source": "google_shopping_product",
"query": "[product_token_string]",
"render": "html",
"parse": True
}
# Get response.
response = requests.request(
'POST',
'https://realtime.oxylabs.io/v1/queries',
auth=('USERNAME', 'PASSWORD'),
json=payload,
)
# Print prettified response to stdout.
pprint(response.json())Important: The query parameter must contain a valid token generated through the google_shopping_search source.
We use synchronous Realtime integration method in our examples. If you would like to use Proxy Endpoint or asynchronous Push-Pull integration, refer to the integration methods section.
Request parameter values
Generic
Basic setup and customization options for scraping Google Shopping product pages.
source
Sets the scraper.
google_shopping_product
query
The product token from google_shopping_search or google_search
-
render
Enables JavaScript rendering when set to html. Required to receive additional pricing results from "More stores" section. More info.
-
- mandatory parameter
Localization
Adapt results to specific geographical locations, domains, and languages.
Note: Localization parameters (gl and hl) are now embedded into the product token. To retrieve google_shopping_products data matching the original search result, we recommend leaving these fields empty unless overrides are intentionally needed.
geo_location
The geographical location that the result should be adapted for. Using this parameter correctly is extremely important to get the right data. For more information, read about our suggested geo_location parameter structures here.
-
Structured data
Below you can find a structured output example for google_shopping_product.
Output data dictionary
HTML sample

JSON structure
The table below presents a detailed list of each product page element we parse, along with its description and data type. The table also includes some metadata.
url
The URL to the Google Shopping product page.
string
title (optional)
The title of the product listing.
string
description
A detailed description of the product.
string
images
An object containing images of the product.
object
images.full_size
An array of URLs for full-sized images of the product.
array
images.thumbnails
An array of URLs for thumbnail images of the product.
array
pricing
An array containing all online pricing information.
array
reviews
An object containing review information. (US only)
object
variants
An array of objects containing product variants. (colors, sizes, etc.)
array
related_items
An array of objects containing related items.
array
specifications
An array of objects containing product specifications.
array
parse_status_code
The status code of the parsing job. You can see the parser status codes described here.
integer
created_at
The timestamp when the scraping job was created.
timestamp
updated_at
The timestamp when the scraping job was finished.
timestamp
status_code
The status code of the scraping job. You can see the scraper status codes described here.
integer
job_id
The ID of the job associated with the scraping job.
string
Pricing
An object containing pricing information for the product.

online
An array of objects containing details of pricing for the product.
array
online.price
The price of the product in the specified currency.
float
online.seller
The name of the seller or merchant offering the product.
string
online.details
Additional details about the product, purchase, such as delivery and return policies.
string
online.currency
The currency code for the product price.
string
online.condition
The condition of the product.
string
online.seller_link
The URL to the seller's page for the product.
string
online.price_shipping
The shipping cost for the product.
float
Reviews
An object containing reviews and ratings information for the product.

rating
The average rating of the product, typically out of 5.
float
top_review (optional)
An object containing details of the top review for the product.
object
top_review.text (optional)
The text content of the top review
string
top_review.title (optional)
The title of the top review.
string
top_review.author (optional)
The author of the top review.
string
top_review.rating (optional)
The rating given by the top review's author, typically out of 5.
float
top_review.source (optional)
The source or website where the top review was posted.
string
rating_stars
The average rating of the product, typically out of 5 stars.
float
reviews_count (optional)
The total number of reviews for the product.
integer
review_count_by_stars
An object containing the count of reviews for each star rating.
object
review_count_by_stars.url (optional)
An object containing details of X-star reviews.
string
review_count_by_stars.reviews_count
The count of X-star reviews.
integer
Related Items (More options)
An array of objects containing related items for the target product.

items
An array of objects containing details of each related item.
array
items.url
The URL to the related product page.
string
items.image
The URL of the related product's image.
string
items.price
The price of the related product in the specified currency.
float
items.title (optional)
The title of the related product listing.
string
items.rating (optional)
The average user rating of the related product, typically out of 5.
integer
items.store (optional)
The name of the store or merchant offering the related product.
string
items.currency
The currency code for the product price.
string
items.reviews_count
The total number of reviews for the related product.
integer
title
The title or heading for the related items section
string
Specifications
An array of objects containing specification details for the product.

items.title
The title of the specification.
string
items.value
The value of the specification.
string
Last updated
Was this helpful?

